;*****************************************************************************
; t@~RvO piyo move test
; Version 1.00
; By kuran_kuran
;*****************************************************************************

;*****************************************************************************
; NES wb_
;*****************************************************************************
	.inesprg 1
	.ineschr 1
	.inesmir 0
	.inesmap 0

;*****************************************************************************
; 荞݃xN^
;*****************************************************************************
	.bank 1
	.org $FFFA
	.dw	VBLANK	; VBlank interrupt
	.dw	START  	; Reset interrupt
	.dw	IRQ	; interrupt

;*****************************************************************************
; ϐ
;*****************************************************************************
	.bank 0
; Zero Page
	.org $0000
Work1	.db	0
Work2	.db	0
Work3	.db	0
Work4	.db	0
Pad	.db	0
; RAM
	.org $0300
; SET_PIYO
PiyoX	.db	0
PiyoY	.db	0
CharNum	.db	0
SprNum	.db	0
Offset	.db	0
; Anime
DirOff	.db	0
Anime	.db	0
AniCnt	.db	0

;*****************************************************************************
; vO
;*****************************************************************************
	.bank 0
	.org $8000

; ********** A荞ݏ
VBLANK:
	rti

; ********** 荞ݏ
IRQ:
	rti

; ********** CvO
START:
	; ********** 
	sei
	cld

	; X^bN
	ldx	#$FF
	txs

	; l[e[ũ~[[h𐅕ɐݒ (cXN[)
;	lda	#%10000000
;	sta	$5FED

	; PPU A VBlank 荞݋֎~
	lda	#%00001000
	sta	$2000

	; 
	jsr	INIT_MEMORY

	; VBlank ɂȂ܂Ń[v
INIT_VBLANK_LOOP:
	lda	$2002
	bpl	INIT_VBLANK_LOOP

	; ̓XvCgABG \
	lda	#%00000000
	sta	$2001

	; pbg
	jsr	SETPALET

	; XvCgABG \
	lda	#%00011000
	sta	$2001

	; \ݒ
	lda	#112
	sta	PiyoX
	lda	#160
	sta	PiyoY
	lda	#0
	sta	CharNum
	lda	#1
	sta	SprNum
	lda	#0
	sta	Offset

	; VBlank 荞݋
	lda	#%10001000
	sta	$2000

	; ********** C[v
MAINLOOP:
	; VBlank ɂȂ܂Ń[v
	lda	$2002
	bpl	MAINLOOP

	; PAD ǂݍ
	lda	#$01
	sta	$4016
	lda	#$00
	sta	$4016
	lda	$4016	; A
	lda	$4016	; B
	lda	$4016	; SELECT
	lda	$4016	; START
	lda	$4016	; UP
	and	#1
	beq	NOT_UP
	dec	PiyoY
	lda	#0
	sta	DirOff
NOT_UP:
	lda	$4016	; DOWN
	and	#1
	beq	NOT_DOWN
	inc	PiyoY
	lda	#96
	sta	DirOff
NOT_DOWN:
	lda	$4016	; LEFT
	and	#1
	beq	NOT_LEFT
	dec	PiyoX
	lda	#32
	sta	DirOff
NOT_LEFT:
	lda	$4016	; RIGHT
	and	#1
	beq	NOT_RIGHT
	inc	PiyoX
	lda	#64
	sta	DirOff
NOT_RIGHT:

	; AjJE^
	inc	AniCnt
	lda	#16
	cmp	AniCnt
	bne	ANIME_CNT
	lda	#0
	sta	AniCnt
	lda	#16
	sec
	sbc	Anime
	sta	Anime
ANIME_CNT:

	; Ђ悱\
	lda	Anime
	clc
	adc	DirOff
	sta	Offset
	jsr	SET_PIYO

	jmp	MAINLOOP

; ********** LN^\
; in :	PiyoX
;	PiyoY
;	CharNum
;	SprNum
SET_PIYO:
	lda	PiyoX
	sta	<$00
	lda	PiyoY
	sta	<$01
	lda	CharNum
	clc
	adc	Offset
	sta	<$02
	lda	SprNum
	asl	a
	asl	a
	sta	<$03

	ldy	#$00
SET_PIYO_L2:
	ldx	#$00
SET_PIYO_L1:
	lda	<$03
	sta	$2003	; SprNum
	clc
	adc	#4
	sta	<$03
	lda	<$01
	sta	$2004	; Y
	lda	<$02
	sta	$2004	; CharNum
	inc	<$02
	lda	#$00
	sta	$2004	; 0
	lda	<$00
	sta	$2004	; X
	clc
	adc	#8
	sta	<$00
	inx
	cpx	#4
	bne	SET_PIYO_L1
	lda	PiyoX
	sta	<$00
	clc
	lda	<$01
	adc	#8
	sta	<$01
	iny
	cpy	#4
	bne	SET_PIYO_L2

	rts

INIT_MEMORY:
	; XvCgNA
	lda	#0
	sta	<$00
	ldx	#$00
SPRITE_CLEAR_L1:
	lda	<$00
	sta	$2003
	clc
	adc	#4
	sta	<$00
	lda	#240
	sta	$2004
	lda	#$00
	sta	$2004
	sta	$2004
	sta	$2004
	inx
	cpx	#64
	bne	SPRITE_CLEAR_L1

	; BG NA
	; $2000`$23BF
	; $2400`$27BF

	; [y[W[NA
	lda	#$00
	ldx	#$00
ZERO_PAGE_CLEAR:
	sta	<$00, x
	inx
	bne	ZERO_PAGE_CLEAR

	; NA
	lda	#$00
	sta	<$00
	lda	#$02
	sta	<$01
	lda	#$00
	ldx	#$00
MEMORY_CLEAR_L2:
	ldy	#$00
MEMORY_CLEAR_L1:
	sta	[$00], y
	iny
	bne	MEMORY_CLEAR_L1
	inx
	inc	<$01
	cpx	#$06
	bne	MEMORY_CLEAR_L2

	; BG NA



	rts

; ********** pbgݒ
SETPALET:
	; XvCg̃pbgݒ
	lda	#$3F
	sta	$2006
	lda	#$10
	sta	$2006
	ldx	#$00
SETPALET_SPRITE_L1:
	lda	PALETTE_00, x
	sta	$2007
	inx
	cpx	#16
	bne	SETPALET_SPRITE_L1

	; BG ̃pbgݒ
	lda	$2002
	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006
	ldx	#$00
SETPALET_BG_L1:
	lda	PALETTE_01, x
	sta	$2007
	inx
	cpx	#16
	bne	SETPALET_BG_L1

	rts

; ********** pbgf[^
PALETTE_00:
	.incbin "piyo.dat"
PALETTE_01:
	.incbin "0f_16.dat"

	.bank 2		; oN 2
	.org $0000	; $0000 Jn

	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
